
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <getopt.h>
#include <syslog.h>
#include <list>
#include <algorithm>

#include "serverSocket.h"
#include "Socket.h"
#include "mysyslog.h"
#include "SMTPproxy.h"
#include "emailHandling.h"

using namespace std;
int sec_smtp_port=15010;

//Procedure to start application as background process (daemon)
int daemon_init(void)
{
  pid_t pid;
                                                                                
  //Turn into daemon (background process)
  pid=fork();
  if ( pid < 0 )
    return(-1);
  else if ( pid!=0 )
    exit(0);
                                                                                
  chdir("/");
  setsid();
  umask(0);
  return(0);
}

//thread to handle client IO
void *clientT(void *csock)
{ 
  pthread_detach(pthread_self());
  writeSyslog("eProxy(THREAD)", LOG_WARNING, LOG_SYSLOG, "thread created");
  Socket *sock=(Socket *)csock;
  SMTPproxy smtp(sock, string("eProxy"));
  writeSyslog("eProxy(PROXY)", LOG_WARNING, LOG_SYSLOG, "proxy started");
  smtp.Run(from, rcptto, body, email, sec_smtp_port); //sec_smtp_port is global; (quick and dirty) since I didn't want to bother with placeholder class or struct
  writeSyslog("eProxy(PROXY)", LOG_WARNING, LOG_SYSLOG, "proxy ended");
  sock->Close();
  writeSyslog("eProxy(SOCKET)", LOG_WARNING, LOG_SYSLOG, "socket closed");	    
  delete sock;
  writeSyslog("eProxy(THREAD)", LOG_WARNING, LOG_SYSLOG, "thread ended");
  pthread_exit(NULL);
  return 0;
}

int main(int argc, char *argv[])
{
  int clntsock;
  char c;
  pthread_t worker;
  
  int port=15009;
  //Parse the commandline options
  while(c!=-1)
  {
    c=getopt(argc, argv, ":p:s:"); 
    switch (c)
    {
      case 'p':
        port=atoi(optarg);
        break;
	  case 's':
		sec_smtp_port=atoi(optarg);
    }
  }

  //start the process into the background
  //daemon_init();

  serverSocket *srv=new serverSocket(port); 
  if ( srv->startListener(false, false) == 0 )
  {
    perror("Can't bind to port!");
    exit(1);
  }
  writeSyslog("eProxy(LISTENER)", LOG_WARNING, LOG_SYSLOG, "listening");
  //start server loop
  while(true)
  {
     usleep(9000);
     clntsock=srv->Accept();
     if (clntsock > 0)
     {
       Socket *sock=new Socket(clntsock);
       pthread_create(&worker, NULL, clientT, sock);
     }
  }
}
